<?xml version="1.0"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:msxsl="urn:schemas-microsoft-com:xslt">


	<xsl:import href="../character/Stat Functions"/>
	<xsl:import href="../character/General String Functions"/>
	<xsl:key name="itemkey" match="item" use="concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name)"/>
	<xsl:output method="html" indent="no" encoding="UTF-8"/>

<xsl:template name='translatebreak'>		
		<xsl:param name='data'/>		
		<xsl:variable name='separator' select='"&#xA;"'/>		
		<xsl:variable name='first' select='substring-before($data,$separator)'/>		
		<xsl:variable name='rest'  select='substring-after($data,$separator)'/>		
		<xsl:choose>			
			<xsl:when test='$rest'>				
				<xsl:call-template name='translatetab'>					
					<xsl:with-param name='data' select='$first'/>					
					<xsl:with-param name='count' select="0"/>				
				</xsl:call-template>				
				<br/>				
				<xsl:call-template name='translatebreak'>					
					<xsl:with-param name='data' select='$rest'/>				
				</xsl:call-template>			
			</xsl:when>			
			<xsl:otherwise>				
				<xsl:call-template name='translatetab'>					
					<xsl:with-param name='data' select='$data'/>					
					<xsl:with-param name='count' select="0"/>				
				</xsl:call-template>				
				<br/>			
			</xsl:otherwise>		
		</xsl:choose>	
	</xsl:template>	
	<xsl:template name='translatetab'>		
		<xsl:param name='data'/>		
		<xsl:param name='count'/>		
		<xsl:variable name='separator' select='"&#x9;"'/>		
		<xsl:variable name='first' select='substring-before($data,$separator)'/>		
		<xsl:variable name='rest'  select='substring-after($data,$separator)'/>		
		<xsl:choose>			
			<xsl:when test='$rest'>				
				<xsl:if test="$count = 0">					
					<xsl:value-of select='$first'/>
					<xsl:variable name='guide'  select="7 - string-length($first)"/>
					<xsl:call-template name='spaces'>
						<xsl:with-param name='guide' select='$guide'/>
					</xsl:call-template>
					<xsl:call-template name='translatetab'>
						<xsl:with-param name='data' select='$rest'/>
						<xsl:with-param name='count' select="$count + 1"/>
					</xsl:call-template>
				</xsl:if>

				<xsl:if test="$count = 1">					
					<xsl:value-of select='$first'/>					
					<xsl:variable name='guide'  select="15 - string-length($first)"/>					
					<xsl:call-template name='spaces'>						
						<xsl:with-param name='guide' select='$guide'/>					
					</xsl:call-template>					
					<xsl:call-template name='translatetab'>						
						<xsl:with-param name='data' select='$rest'/>						
						<xsl:with-param name='count' select="$count + 1"/>					
					</xsl:call-template>				
				</xsl:if>				
				<xsl:if test="$count &gt; 1">					
					<xsl:value-of select='$first'/>					
					<xsl:variable name='guide'  select="20 - string-length($first)"/>					
					<xsl:call-template name='spaces'>						
						<xsl:with-param name='guide' select='$guide'/>					
					</xsl:call-template>					
					<xsl:call-template name='translatetab'>						
						<xsl:with-param name='data' select='$rest'/>						
						<xsl:with-param name='count' select="$count + 1"/>					
					</xsl:call-template>				
				</xsl:if>			
			</xsl:when>			
			<xsl:otherwise>				
				<xsl:choose>					
					<xsl:when test="$count &gt; 0">						
						<xsl:value-of select='$data'/>					
					</xsl:when>					
					<xsl:otherwise>						
						<xsl:value-of select='$data'/>					
					</xsl:otherwise>				
				</xsl:choose>			
			</xsl:otherwise>		
		</xsl:choose>	
	</xsl:template>	
	<xsl:template name='spaces'>		
		<xsl:param name='guide'/>		
		<xsl:if test="$guide &gt; 0">			
			<xsl:text disable-output-escaping="yes">&amp;#160;</xsl:text>			
			<xsl:call-template name='spaces'>				
				<xsl:with-param name='guide' select='$guide - 1'/>			
			</xsl:call-template>		
		</xsl:if>	
	</xsl:template>	

<xsl:template match="/monster">


<font style="font-size:8pt">
<xsl:value-of select="name"/>



<br/>

	<xsl:choose>
	<xsl:when test="gender != ''">


	<xsl:for-each select="templates/name">
		<xsl:value-of select="."/>
			<xsl:text> </xsl:text>
	</xsl:for-each>

		<xsl:choose>
		<xsl:when test="contains(race,',')">
			<xsl:variable name="race1" select="translate(normalize-space(substring-before(race,',')),' ',' ')"/>
			<xsl:value-of select="$race1"/>
			<xsl:variable name="subrace1" select="translate(normalize-space(substring-after(race,',')),',',' ')"/>
			<xsl:variable name="subrace2" select="translate($subrace1,' ',' ')"/>
			<xsl:text> (</xsl:text>
			<xsl:value-of select="$subrace2"/>
			<xsl:text>)</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="translate(normalize-space(race),' ',' ')"/>
		</xsl:otherwise>
		</xsl:choose>
		<xsl:text> </xsl:text>
		<xsl:value-of select="classes/string"/>
	</xsl:when>
	<xsl:otherwise>
		<xsl:value-of select="class"/>
	</xsl:otherwise>
	</xsl:choose>

<xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>

<xsl:text> (CR </xsl:text>

	<xsl:choose>
	<xsl:when test="challenge-rating != 0">
		<xsl:value-of select="challenge-rating"/>
<xsl:text>, </xsl:text>
	</xsl:when>
	<xsl:otherwise>
		<xsl:value-of select="classes/total"/>
<xsl:text>, </xsl:text>
	</xsl:otherwise>
	</xsl:choose>

	<xsl:variable name="hpbonus">
	    <xsl:for-each select="hit-dice/hit-die">
	        <acc><xsl:value-of select="substring-after(bonus,'+')"/></acc>
	    </xsl:for-each>
	</xsl:variable>
	HD
	<xsl:text> </xsl:text>
	<xsl:for-each select="hit-dice/hit-die">
		<xsl:value-of select="die"/>
		<xsl:text></xsl:text>

		<xsl:choose>
		<xsl:when test="position() = last()">
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>+</xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>
	<xsl:choose>
        <xsl:when test="sum(msxsl:node-set($hpbonus)/acc) > 0">
	        <xsl:text>+</xsl:text>
	        <xsl:value-of select="sum(msxsl:node-set($hpbonus)/acc)"/>
	</xsl:when>
	</xsl:choose>
	<xsl:text>) </xsl:text>

<br/>

<xsl:value-of select="alignment/abbr"/> 
	<xsl:text> </xsl:text>

	<xsl:value-of select="size/category"/>
	<xsl:text> </xsl:text>
	<xsl:value-of select="size/type"/>
	<xsl:if test="size/subtype != ''">
	<xsl:text> </xsl:text>
	<xsl:value-of select="size/subtype"/>
	</xsl:if>
	<xsl:text> </xsl:text>

<br/>

<xsl:variable name="init" select="sum(initiative/modifiers/modifier[@name != 'misc']/@value)"/>
	<b><xsl:text>Init </xsl:text></b>
	<xsl:if test="$init >= 0">
		<xsl:text>+</xsl:text>
	</xsl:if>
	<xsl:value-of select="$init"/>
	<xsl:text> </xsl:text>

	<b><xsl:text>Spd </xsl:text></b>
	<xsl:for-each select="speeds/speed">
		<xsl:if test="position() &gt; 1">
			<xsl:text> or </xsl:text>
		</xsl:if>
		<xsl:choose>
		<xsl:when test="name = 'Base'">
			<xsl:value-of select="value"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="name"/>
			<xsl:text> </xsl:text>
			<xsl:value-of select="value"/>
		</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="position() = last()">
			<xsl:text> </xsl:text>
		</xsl:if>
	</xsl:for-each>

<br/>

	<xsl:for-each select="features/special-qualities/special-quality">
		<xsl:if test="position() = 1">
		<b><xsl:text>Senses </xsl:text></b>
		</xsl:if>
		<xsl:if test="contains(.,'Darkvision') or contains(.,'Vision') or contains(.,'Blindsight') or contains(.,'Blindsense') or contains(.,'See') or contains(.,'Scent') or contains(.,'Sense') or contains(.,'Detect') or contains(.,'Sight') or contains (.,'Tremorsense')">
		<xsl:value-of select="."/>
		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text> </xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>; </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
		</xsl:if>
	</xsl:for-each>





<xsl:for-each select="skills/skill">
		<xsl:sort select="string(.)"/>
		<xsl:if test="position() = 1">
	<xsl:text> | </xsl:text>
		</xsl:if>
		<xsl:if test="name='Listen' or name ='Spot'">
			<xsl:value-of select="name"/>
			<xsl:text> </xsl:text>
			<xsl:if test="sum(modifiers/modifier[@name != 'misc']/@value) >= 0">
			<xsl:text>+</xsl:text>
			</xsl:if>
			<xsl:value-of select="sum(modifiers/modifier[@name != 'misc']/@value)"/>
			<xsl:choose>
			<xsl:when test="name ='Spot'">
				<xsl:text> </xsl:text> 
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>, </xsl:text>
			</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:for-each>

<br/>
<hr/>
<font color="red" style="font-size:8pt">
<b>AC 

		<xsl:variable name="enhance-bonus" select="sum(active-magic-bonuses/magic-bonus[type='Enhancement' and name='AC']/bonus)"/>
		<xsl:variable name="dodge-bonus" select="sum(active-magic-bonuses/magic-bonus[type='Dodge' and name='AC']/bonus)"/>
		<xsl:variable name="magicarmorbonus" select="sum(active-magic-bonuses/magic-bonus[type='Armor' and name='AC']/bonus)"/>
			<xsl:value-of select="sum(armor-class/modifiers/modifier[@name != 'misc']/@value)"/>

		<xsl:text> (FF </xsl:text> 	
	<!-- needs to be passed All class features with something like "features/class-features//feature" -->
		<!-- check if has uncanny dodge -->
		<xsl:variable name="uncanny-dodge-found">
			<xsl:for-each select="/*/features/class-features/class-feature/feature">
				<xsl:if test=". = 'Uncanny Dodge (Dex bonus to AC)' or . = 'Uncanny Dodge'">
					<xsl:text>T</xsl:text>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="/*/features/feats/feat/name">
				<xsl:if test=". = 'Intuitive Sense (Ceremonial)'">
					<xsl:text>T</xsl:text>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="dex-adjustment">
			<xsl:choose>
				<xsl:when test="contains($uncanny-dodge-found,'T')">
					<xsl:value-of select="0-($dodge-bonus)"/>
				</xsl:when>
				<!-- keep dex adjustment and dodge bonus if has uncanny dodge -->
				<xsl:when test="/*/armor-class/modifiers/modifier[@name = 'ability']/@value &lt;= 0">0</xsl:when>
				<!-- keep dex penalty -->
				<xsl:otherwise>
					<xsl:value-of select="/*/armor-class/modifiers/modifier[@name = 'ability']/@value"/>
					<!-- ignore dex bonus -->
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:value-of select="sum(/*/armor-class/modifiers/modifier[@name != 'misc']/@value)-($dex-adjustment)-($dodge-bonus)"/>

			<xsl:text>, Touch </xsl:text>
			<xsl:value-of select="sum(armor-class/modifiers/modifier[@name != 'misc']/@value)-(armor-class/modifiers/modifier[@name = 'armor']/@value)-(armor-class/modifiers/modifier[@name = 'shield']/@value)-(armor-class/modifiers/modifier[@name = 'natural']/@value)-($enhance-bonus)-($magicarmorbonus)"/>)</b>
</font>

<br/>

hp <xsl:value-of select="hit-points"/>

	<xsl:text> (Disabled </xsl:text>
	<xsl:choose>
	<xsl:when test="saving-throws/saving-throw[1]/modifiers/modifier[@name = 'ability']/@value > 0">
		<xsl:text>-</xsl:text>
		<xsl:value-of select="saving-throws[1]/saving-throw/modifiers/modifier[@name = 'ability']/@value"/>
		<xsl:text>/</xsl:text>
	</xsl:when>
	<xsl:otherwise>
		<xsl:text>0/</xsl:text>
	</xsl:otherwise>
	</xsl:choose>
	
	<xsl:for-each select="abilities">
	<xsl:text>Dying -</xsl:text>

		<xsl:value-of select="ability[3]/base"/>

	<xsl:text>/Injury </xsl:text>
		<xsl:variable name="conmod" select="ability[3]/base"/>
		<xsl:variable name="hps" select="/*/hit-points"/>
		<xsl:choose>
		<xsl:when test="$conmod > $hps">
			<xsl:value-of select="/*/hit-points"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="ability[3]/base"/>
		</xsl:otherwise>
		</xsl:choose>
	<xsl:text>) </xsl:text>
	</xsl:for-each>



<br/>

	<b><xsl:text>Saves: </xsl:text></b>
	<xsl:for-each select="saving-throws/saving-throw">
		<xsl:value-of select="abbr"/>
		<xsl:text> </xsl:text>

		<xsl:variable name="save" select="sum(modifiers/modifier[@name != 'misc']/@value)"/>
		<xsl:if test="$save >= 0">
		<xsl:text> +</xsl:text>
		</xsl:if>
		<xsl:value-of select="$save"/>

		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:if test="/character/notes/reference != ''">
				(<xsl:value-of select="/character/notes/reference"/>)
			</xsl:if>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>, </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>

<br/>
<b>
<font color="purple" style="font-size:8pt">
<xsl:for-each select="features/special-qualities/special-quality">
		<xsl:if test="contains(.,'Resistance') or contains(.,'Immunity') or contains(.,'Reduction') or contains(.,'Fast Healing') or contains(.,'Regeneration') or contains(.,'Vulnerability') or contains(.,'Saves vs.')">
		<xsl:value-of select="."/>
		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text> </xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>, </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
		</xsl:if>
	</xsl:for-each>
</font>


<font color="purple" style="font-size:8pt">
<xsl:for-each select="equiped-items/protective-item">
		<xsl:if test="contains(special-properties,'resistance') or contains(special-properties,'Immunity') or contains(special-properties,'Resistance') or contains(special-properties,'immunity') or contains(special-properties,'reduction') or contains(special-properties,'immunity') or contains(special-properties,'immune') or contains(special-properties,'miss chance') or contains(special-properties,'displacement') or contains(special-properties,'absorb') or contains(special-properties,'countered')">
		<xsl:value-of select="name"/>
		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text> </xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>; </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
		</xsl:if>
	</xsl:for-each>
</font>
</b>
<hr/>

		<b><xsl:text>Atk </xsl:text></b>
			<xsl:for-each select="attacks/melee">
				<xsl:value-of select="attack-string"/>
				<xsl:text> base melee, </xsl:text>
			</xsl:for-each>

			<xsl:for-each select="attacks/ranged">
				<xsl:value-of select="attack-string"/>
				<xsl:text> base ranged; </xsl:text>
			</xsl:for-each>

	<xsl:text> Grapple </xsl:text>

		<xsl:variable name="base" select="/*/attacks/melee/modifiers/modifier[@name = 'base']/@value"/>
		<xsl:variable name="str-mod" select="/*/attacks/melee/modifiers/modifier[@name = 'ability']/@value"/>
		<xsl:variable name="special-size-mod">
			<xsl:choose>
				<xsl:when test="/*/size/category = 'Colossal'">16</xsl:when>
				<xsl:when test="/*/size/category = 'Gargantuan'">12</xsl:when>
				<xsl:when test="/*/size/category = 'Huge'">8</xsl:when>
				<xsl:when test="/*/size/category = 'Large'">4</xsl:when>
				<xsl:when test="/*/size/category = 'Small'">-4</xsl:when>
				<xsl:when test="/*/size/category = 'Tiny'">-8</xsl:when>
				<xsl:when test="/*/size/category = 'Diminutive'">-12</xsl:when>
				<xsl:when test="/*/size/category = 'Fine'">-16</xsl:when>
				<xsl:otherwise>0</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:call-template name="signed-num">
			<xsl:with-param name="number" select="$base + $str-mod + $special-size-mod"/>
		</xsl:call-template>

	<xsl:text>; </xsl:text>

		<xsl:choose>
		<xsl:when test="size/face/x != '5' and size/face/y != '5'">
	<xsl:text>Face </xsl:text>
		<xsl:value-of select="//size/face/x"/>
			<xsl:text>'x</xsl:text>
                <xsl:value-of select="//size/face/y"/>
			<xsl:text>'; </xsl:text>
		</xsl:when>
		</xsl:choose>

		<xsl:choose>
		<xsl:when test="size/reach != '5'">
	<xsl:text>Reach </xsl:text>
		<xsl:value-of select="//size/reach"/>
			<xsl:text>'; </xsl:text>
		</xsl:when>
		</xsl:choose>

		<xsl:for-each select="equiped-items/weapons">
		<br/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
			<xsl:for-each select="weapon">

					<xsl:variable name="basebonus1" select="/character/attacks/base"/>
					<xsl:variable name="basebonus2" select="substring($basebonus1,2) - 5"/>
					<xsl:variable name="basebonus3" select="substring($basebonus1,2) - 10"/>
					<xsl:variable name="basebonus4" select="substring($basebonus1,2) - 15"/>
					<xsl:variable name="basemonk2" select="substring($basebonus1,2) - 3"/>
					<xsl:variable name="basemonk3" select="substring($basebonus1,2) - 6"/>
					<xsl:variable name="basemonk4" select="substring($basebonus1,2) - 9"/>
					<xsl:variable name="basemonk5" select="substring($basebonus1,2) - 12"/>
					<xsl:variable name="basemonk6" select="substring($basebonus1,2) - 15"/>
					<xsl:variable name="tmpbonus1" select="bonus"/>
					<xsl:variable name="tmpbonus2" select="substring($tmpbonus1,2) - 5"/>
					<xsl:variable name="tmpbonus3" select="substring($tmpbonus1,2) - 10"/>
					<xsl:variable name="tmpbonus4" select="substring($tmpbonus1,2) - 15"/>
					<xsl:variable name="mnkbonus2" select="substring($tmpbonus1,2) - 3"/>
					<xsl:variable name="mnkbonus3" select="substring($tmpbonus1,2) - 6"/>
					<xsl:variable name="mnkbonus4" select="substring($tmpbonus1,2) - 9"/>
					<xsl:variable name="mnkbonus5" select="substring($tmpbonus1,2) - 12"/>
					<xsl:variable name="mnkbonus6" select="substring($tmpbonus1,2) - 15"/>

				<xsl:if test="position() > 1">
					<i><xsl:text> and </xsl:text></i>
				</xsl:if>

			<xsl:choose>

			<xsl:when test="monk-weapon = '1' and /character/classes/class/name = 'Monk'">
					<xsl:value-of select="$tmpbonus1"/>
					<xsl:if test="$basemonk2 > 0">
					<xsl:text>/</xsl:text>
					<xsl:value-of select="$mnkbonus2"/>
					</xsl:if>
					<xsl:if test="$basemonk3 > 0">
					<xsl:text>/</xsl:text>
					<xsl:value-of select="$mnkbonus3"/>
					</xsl:if>
					<xsl:if test="$basemonk4 > 0">
					<xsl:text>/</xsl:text>
					<xsl:value-of select="$mnkbonus4"/>
					</xsl:if>
					<xsl:if test="$basemonk5 > 0">
					<xsl:text>/</xsl:text>
					<xsl:value-of select="$mnkbonus5"/>
					</xsl:if>
					<xsl:if test="$basemonk6 > 0">
					<xsl:text>/</xsl:text>
					<xsl:value-of select="$mnkbonus6"/>
					</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<b><xsl:value-of select="attack-string"/></b>
			</xsl:otherwise>
		</xsl:choose>
					<xsl:text> </xsl:text>
				<b><xsl:value-of select="type"/></b>
				<xsl:text> (</xsl:text>
				<xsl:choose>
				<xsl:when test="starts-with(name, '+')">
				<i><xsl:value-of select="name"/></i>
				</xsl:when>
				<xsl:otherwise>
				<xsl:value-of select="name"/>
				</xsl:otherwise>
				</xsl:choose>
					<xsl:text> </xsl:text>
				<xsl:value-of select="damage"/>
		<xsl:text>/</xsl:text>

			<xsl:text>crit </xsl:text>
			<xsl:choose>
                        <xsl:when test="contains(critical,'20')">
				<xsl:value-of select="normalize-space(substring-before(critical,'20'))"/>
				<xsl:text>20/</xsl:text>
				<xsl:choose>
				<xsl:when test ="contains(critical,'x')">
					<xsl:text>x</xsl:text>
					<xsl:value-of select="normalize-space(substring-after(critical,'x'))"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>x2</xsl:text>
				</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
                        <xsl:otherwise>
				<xsl:text>20/</xsl:text>
				<xsl:choose>
				<xsl:when test ="contains(critical,'x')">
					<xsl:text>x</xsl:text>
					<xsl:value-of select="normalize-space(substring-after(critical,'x'))"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>x2</xsl:text>
				</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
			</xsl:choose>
					<xsl:text>)</xsl:text>
			</xsl:for-each>
				<xsl:text>; </xsl:text>
		</xsl:for-each>
		<br/>
	<xsl:for-each select="features/special-attacks/special-attack">
		<xsl:if test="position() = 1">
<b><xsl:text>SA: </xsl:text></b>
		</xsl:if>

			<xsl:choose>
			<xsl:when test="name = 'Spell-like abilities' or name = 'Spell-like Abilities' or name = 'Psionics (Sp)' or name = 'Psionics (Su)' or name = 'Psi-Like Abilities'">
			<xsl:for-each select="spell">
				<xsl:if test="position() = 1">
				<xsl:text>Spell-Like Abilities (</xsl:text>
				</xsl:if>
				<i><xsl:value-of select="name"/></i>
					<xsl:text>, CL </xsl:text>
				<xsl:value-of select="caster-level"/>
					<xsl:text>, </xsl:text>
				<xsl:value-of select="times-per-day"/>
						<xsl:choose>
						<xsl:when test="times-per-day = 'At Will'">
						<xsl:text></xsl:text>
						</xsl:when>
						<xsl:otherwise>
						<xsl:text>/day</xsl:text>
						</xsl:otherwise>
						</xsl:choose>
				<xsl:choose>
				<xsl:when test="position() = last()">
				<xsl:text>) </xsl:text>
				</xsl:when>
				<xsl:otherwise>
				<xsl:text>; </xsl:text>
				</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
				</xsl:when>
				<xsl:otherwise>
				
		<xsl:value-of select="."/>
				</xsl:otherwise>
				</xsl:choose>			
		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text> </xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>, </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>

	<xsl:for-each select="features/special-qualities/special-quality">
		<xsl:if test="position() = 1">
		<br/>
			<b><xsl:text>SQ: </xsl:text></b>
		</xsl:if>

		<xsl:choose>
		<xsl:when test="contains(.,'Resistance') or contains(.,'Immunity') or contains(.,'Reduction') or contains(.,'Fast Healing') or contains(.,'Regeneration') or contains(.,'Vulnerability') or contains(.,'Darkvision') or contains(.,'Vision') or contains(.,'Blindsight') or contains(.,'Blindsense') or contains(.,'See') or contains(.,'Scent') or contains(.,'Sense') or contains(.,'Detect') or contains(.,'Sight') or contains (.,'Tremorsense') or contains(.,'Saves vs.') or contains(.,'No Dual Nature')">

		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="."/>


		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text> </xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>, </xsl:text>
		</xsl:otherwise>
		</xsl:choose>

		</xsl:otherwise>
		</xsl:choose>

	</xsl:for-each>

<xsl:for-each select="features/race-features/race-feature">
		<xsl:if test="position() = 1">
		<br/>	<b><xsl:text>Racial Features: </xsl:text></b>
		</xsl:if>
		<xsl:value-of select="."/>

		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text> </xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>, </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>

<hr/>

<b><xsl:text>Abilities </xsl:text></b>
	<xsl:for-each select="abilities/ability">
		<xsl:value-of select="abbr"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select="base"/>

		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text> </xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>, </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>

	<xsl:for-each select="features/feats/feat">
		<xsl:sort select="string(.)"/>
		<xsl:if test="position() = 1">
			<br/><b>Feats: </b>
		</xsl:if>
		<xsl:value-of select="name"/>
		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text>.</xsl:text>

		</xsl:when>
		<xsl:otherwise>
			<xsl:text>, </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>

	<xsl:for-each select="skills/skill[modifiers/modifier[@name = 'rank' or @name = 'race' or @name = 'magic' or @name = 'feat' or @name = 'other']/@value &gt; 0]">
		<xsl:sort select="string(.)"/>
		<xsl:if test="position() = 1">
			<br/><b>Skills: </b>
		</xsl:if>
		<xsl:value-of select="name"/>
		<xsl:if test="sum(modifiers/modifier[@name != 'misc']/@value) >= 0">
			 +
		</xsl:if>
		<xsl:value-of select="sum(modifiers/modifier[@name != 'misc']/@value)"/> 
		<xsl:choose>
		<xsl:when test="position() = last()">
			<xsl:text>. </xsl:text><br/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>, </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>




	<xsl:apply-templates select="items"/>
<hr/>
	<xsl:if test="notes/special-attacks != ''">					
			<b>Special Attacks: </b>			
			<xsl:call-template name='translatebreak'>				
				<xsl:with-param name='data' select="notes/special-attacks"/>
			</xsl:call-template>		
		</xsl:if>		

	<xsl:if test="notes/special-qualities != ''">				
			<b>Special Qualities: </b>			
			<xsl:call-template name='translatebreak'>				
				<xsl:with-param name='data' select="notes/special-qualities"/>
			</xsl:call-template>		
		</xsl:if>		

<xsl:if test="spells-known/class/name != ''">
	<xsl:for-each select="spells-known/class">
		<xsl:if test="full-name != 'Cleric'">

<hr/><b>Spells Known <xsl:value-of select="name"/>: </b>

		<xsl:if test="count(spell[level = '0']) > 0">
			<xsl:text>0 - </xsl:text>
			<xsl:for-each select="spell[level = '0']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '1']) > 0">
			<xsl:text>; 1st - </xsl:text>
			<xsl:for-each select="spell[level = '1']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '2']) > 0">
			<xsl:text>; 2nd - </xsl:text>
			<xsl:for-each select="spell[level = '2']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '3']) > 0">
			<xsl:text>; 3rd - </xsl:text>
			<xsl:for-each select="spell[level = '3']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '4']) > 0">
			<xsl:text>; 4th - </xsl:text>
			<xsl:for-each select="spell[level = '4']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '5']) > 0">
			<xsl:text>; 5th - </xsl:text>
			<xsl:for-each select="spell[level = '5']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '6']) > 0">
			<xsl:text>; 6th - </xsl:text>
			<xsl:for-each select="spell[level = '6']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '7']) > 0">
			<xsl:text>; 7th - </xsl:text>
			<xsl:for-each select="spell[level = '7']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '8']) > 0">
			<xsl:text>; 8th - </xsl:text>
			<xsl:for-each select="spell[level = '8']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '9']) > 0">
			<xsl:text>; 9th - </xsl:text>
			<xsl:for-each select="spell[level = '9']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>
		<xsl:text>.</xsl:text>

		</xsl:if>
	</xsl:for-each>
</xsl:if>

<xsl:if test="spells-prepared/class/name != ''">
	<xsl:for-each select="spells-prepared/class">
<hr/><b>Spells Prepared <xsl:value-of select="name"/>: </b>

		<xsl:if test="count(spell[level = '0']) > 0">
			<xsl:text>0 - </xsl:text>
			<xsl:for-each select="spell[level = '0']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '1']) > 0">
			<xsl:text>; 1st - </xsl:text>
			<xsl:for-each select="spell[level = '1']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '2']) > 0">
			<xsl:text>; 2nd - </xsl:text>
			<xsl:for-each select="spell[level = '2']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '3']) > 0">
			<xsl:text>; 3rd - </xsl:text>
			<xsl:for-each select="spell[level = '3']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '4']) > 0">
			<xsl:text>; 4th - </xsl:text>
			<xsl:for-each select="spell[level = '4']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '5']) > 0">
			<xsl:text>; 5th - </xsl:text>
			<xsl:for-each select="spell[level = '5']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '6']) > 0">
			<xsl:text>; 6th - </xsl:text>
			<xsl:for-each select="spell[level = '6']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '7']) > 0">
			<xsl:text>; 7th - </xsl:text>
			<xsl:for-each select="spell[level = '7']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '8']) > 0">
			<xsl:text>; 8th - </xsl:text>
			<xsl:for-each select="spell[level = '8']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>

		<xsl:if test="count(spell[level = '9']) > 0">
			<xsl:text>; 9th - </xsl:text>
			<xsl:for-each select="spell[level = '9']">
				<xsl:sort select="string(.)"/>
				<i><xsl:value-of select="name"/><xsl:apply-templates select="count"/></i>
				<xsl:choose>
				<xsl:when test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:if>
		<xsl:text>.</xsl:text>
	</xsl:for-each>
</xsl:if>
</font>
</xsl:template>

<xsl:template match="items">

	<xsl:if test="/*/currency/value != 0">
		<b><xsl:text>Coins: </xsl:text></b>
		<xsl:choose>
			<xsl:when test="/*/currency/pp > 0">
				<xsl:value-of select="/*/currency/pp"/>
				<xsl:text> pp</xsl:text>
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="/*/currency/gp > 0">
				<xsl:if test="/*/currency/pp &gt; 0">				
					<xsl:text>, </xsl:text>			
				</xsl:if>			
				<xsl:value-of select="/*/currency/gp"/>
				<xsl:text> gp</xsl:text>		
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="/*/currency/sp &gt; 0">			
				<xsl:if test="/*/currency/pp &gt; 0 or /*/currency/gp &gt; 0">				
					<xsl:text>, </xsl:text>			
				</xsl:if>			
				<xsl:value-of select="/*/currency/sp"/>
				<xsl:text> sp</xsl:text>		
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="/*/currency/cp &gt; 0">			
				<xsl:if test="/*/currency/pp &gt; 0 or /*/currency/gp &gt; 0 or /*/currency/sp &gt; 0">				
					<xsl:text>, </xsl:text>			
				</xsl:if>			
				<xsl:value-of select="/*/currency/cp"/>
				<xsl:text> cp</xsl:text>		
			</xsl:when>
		</xsl:choose>
		<xsl:text>. </xsl:text>	
	</xsl:if>
	

		<xsl:variable name="weapon1">
			<xsl:for-each select="/*/items/item[ generate-id(.)=generate-id(key('itemkey',concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name))[1]) and type = 'Weapon']">
				<xsl:sort select="name" order="ascending"/>
				<xsl:variable name="n" select="concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name)"/>
				<xsl:variable name="count" select="count(/*/items/item[concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name) = $n])"/>
					<xsl:value-of select="name"/>
					<xsl:if test="$count > 1">
						<xsl:text> x</xsl:text>
						<xsl:value-of select="$count"/>
					</xsl:if>
					<xsl:choose>
						<xsl:when test="position() != last()">
							<xsl:text>; </xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>. </xsl:text>
						</xsl:otherwise>
					</xsl:choose>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="armor1">
			<xsl:for-each select="/*/items/item[ generate-id(.)=generate-id(key('itemkey',concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name))[1]) and type = 'Armor']">
				<xsl:sort select="name" order="ascending"/>
				<xsl:variable name="n" select="concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name)"/>
				<xsl:variable name="count" select="count(/*/items/item[concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name) = $n])"/>
					<xsl:value-of select="name"/>
					<xsl:if test="$count > 1">
						<xsl:text> x</xsl:text>
						<xsl:value-of select="$count"/>
					</xsl:if>
					<xsl:choose>
						<xsl:when test="position() != last()">
							<xsl:text>; </xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>. </xsl:text>
						</xsl:otherwise>
					</xsl:choose>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="shield1">
			<xsl:for-each select="/*/items/item[ generate-id(.)=generate-id(key('itemkey',concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name))[1]) and type = 'Shield']">
				<xsl:sort select="name" order="ascending"/>
				<xsl:variable name="n" select="concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name)"/>
				<xsl:variable name="count" select="count(/*/items/item[concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name) = $n])"/>
					<xsl:value-of select="name"/>
					<xsl:if test="$count > 1">
						<xsl:text> x</xsl:text>
						<xsl:value-of select="$count"/>
					</xsl:if>
					<xsl:choose>
						<xsl:when test="position() != last()">
							<xsl:text>; </xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>. </xsl:text>
						</xsl:otherwise>
					</xsl:choose>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="goods1">
			<xsl:for-each select="/*/items/item[ generate-id(.)=generate-id(key('itemkey',concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name))[1]) and (type = 'Goods' or type = 'Art' or type = 'Gem')]">
				<xsl:sort select="name" order="ascending"/>
				<xsl:variable name="n" select="concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name)"/>
				<xsl:variable name="count" select="count(/*/items/item[concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name) = $n])"/>
					<xsl:value-of select="name"/>
						<xsl:if test="type = 'Art' or type = 'Gem'">
					<xsl:text> (</xsl:text>
					<xsl:value-of select="format-number(cost/@value, '#,###,###,##0')"/>
					<xsl:text> </xsl:text>
					<xsl:value-of select="cost/@name"/>
					<xsl:text>)</xsl:text>
						</xsl:if>
					<xsl:if test="$count > 1">
						<xsl:text> x</xsl:text>
						<xsl:value-of select="$count"/>
					</xsl:if>
					<xsl:choose>
						<xsl:when test="position() != last()">
							<xsl:text>; </xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>. </xsl:text>
						</xsl:otherwise>
					</xsl:choose>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="magic1">
			<xsl:for-each select="/*/items/item[ generate-id(.)=generate-id(key('itemkey',concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name))[1]) and (type = 'Potion' or type = 'Ring' or type = 'Rod' or type = 'Scroll' or type = 'Staff' or type = 'Wand' or type = 'Wondrous')]">
				<xsl:sort select="name" order="ascending"/>
				<xsl:variable name="n" select="concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name)"/>
				<xsl:variable name="count" select="count(/*/items/item[concat(type, ': ', name , ': ', cost/@value , ': ', cost/@name) = $n])"/>
						<xsl:if test="type != 'Wondrous'">
					<xsl:value-of select="type"/>
					<xsl:text> of </xsl:text>
						</xsl:if>
					<xsl:value-of select="name"/>
					<xsl:if test="$count > 1">
						<xsl:text> x</xsl:text>
						<xsl:value-of select="$count"/>
					</xsl:if>
					<xsl:choose>
						<xsl:when test="position() != last()">
							<xsl:text>; </xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>. </xsl:text>
						</xsl:otherwise>
					</xsl:choose>
			</xsl:for-each>
		</xsl:variable>
		<xsl:if test="$weapon1 != ''">
			<b><xsl:text>Weapons: </xsl:text></b>
			<xsl:value-of select="$weapon1"/>
		</xsl:if>
		<xsl:if test="$armor1 != ''">
			<b>Armor:</b><xsl:text> </xsl:text>
			<xsl:value-of select="$armor1"/>
		</xsl:if>
		<xsl:if test="$shield1 != ''">
			<b>Shields:</b><xsl:text> </xsl:text>
			<xsl:value-of select="$shield1"/>
		</xsl:if>
		<xsl:if test="$goods1 != ''">
			<b>Goods:</b><xsl:text> </xsl:text>
			<xsl:value-of select="$goods1"/>
		</xsl:if>
		<xsl:if test="$magic1 != ''">
			<b>Magic:</b><xsl:text> </xsl:text>
			<xsl:value-of select="$magic1"/>
		</xsl:if>

		<xsl:choose>
		<xsl:when test="/*/items/item != '' or /*/currency != ''">
			<br/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text> </xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


<xsl:template match="count">
	<xsl:if test=". &gt; 1">
		<xsl:text> x</xsl:text><xsl:value-of select="."/>
	</xsl:if>
</xsl:template>

</xsl:stylesheet>










